﻿package  
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.filters.ColorMatrixFilter;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.media.Video;
	import flash.media.Camera;
	/**
	* ...
	* @author Carly Gooch
	*/
	public class NightVisionCamera extends Sprite
	{
		
		private var video:Video;
		private var imageData:BitmapData;
		private var image:Bitmap;
		
		private const RED:Number = 0.1;
		private const GREEN:Number = 0.5;
		private const BLUE:Number = 0.1;
		
		public function NightVisionCamera() 
		{
			
			video = new Video()
			video.attachCamera(Camera.getCamera());
			
			imageData = new BitmapData(video.width, video.height, false,0x000000);
			image = new Bitmap(imageData);
			
			this.addEventListener(Event.ENTER_FRAME, applyNightVision);
			this.addChild(image);
			
			this.addChild(video);
			image.x = video.width;
		}
		
		private function applyNightVision(e:Event):void 
		{
			imageData.draw(video);
			
			var matrix:Array = new Array();
            matrix = matrix.concat([RED, RED,RED, 0, 0]); // red
            matrix = matrix.concat([GREEN, GREEN, GREEN, 0, 0]); // green
            matrix = matrix.concat([BLUE, BLUE, BLUE, 0, 0]); // blue
            matrix = matrix.concat([0, 0, 0, 1, 0]); // alpha
			
			var filter:ColorMatrixFilter = new ColorMatrixFilter(matrix);
            var filters:Array = new Array();
            filters.push(filter);
			
			var blutFilter:BlurFilter = new BlurFilter(2, 2, 1);
			filters.push(blutFilter);
			
			var noiseBitmapData:BitmapData = new BitmapData(image.width, image.height);
			noiseBitmapData.noise(Math.floor(Math.random()*100),0,255,7,true);
			image.filters = filters;
			image.bitmapData.merge(noiseBitmapData, new Rectangle(0, 0, image.width, image.height), new Point(0, 0), 25,25, 25, .2);
		}
		
	}
	
}